/* global tinyMCE */
(function($){
	var media = wp.media, shortcode_string = 'pm_tailored_img';
	wp.mce = wp.mce || {};
	wp.mce.pm_tailored_img = {
		shortcode_data: {},
		template: media.template( 'timg-editor-template' ),
		className: 'pm-timg-editor',
		getContent: function() {
			var options = this.shortcode.attrs.named;
			options.innercontent = this.shortcode.content;
			return this.template(options);
		},
		View: { // before WP 4.2:
			template: media.template( 'timg-editor-template' ),
			className: 'pm-timg-editor',
			postID: $('#post_ID').val(),
			initialize: function( options ) {
				this.shortcode = options.shortcode;
				wp.mce.pm_tailored_img.shortcode_data = this.shortcode;
			},
			getHtml: function() {
				var options = this.shortcode.attrs.named;
				options.innercontent = this.shortcode.content;
				return this.template(options);
			}
		},
		edit: function( data ) {
			var shortcode_data = wp.shortcode.next(shortcode_string, data);
			var values = shortcode_data.shortcode.attrs.named;
			values.innercontent = shortcode_data.shortcode.content;
			wp.mce.pm_tailored_img.popupwindow(tinyMCE.activeEditor, values);
		},
		// this is called from our tinymce plugin, also can call from our "edit" function above
		// wp.mce.pm_tailored_img.popupwindow(tinyMCE.activeEditor, "pmtimgbuttons");
		popupwindow: function(editor, values, onsubmit_callback, url){
			values = values || [];
			editor.windowManager.open( {
				title: pm_timg_tmce_obj.plugin_name,
				url: pm_timg_tmce_obj.plugin_url+'admin/js/editor/index.php',
				width: jQuery(window).width() * 0.3,
				height: (jQuery(window).height() - 36 - 50) * 0.6,
				//onsubmit: onsubmit_callback
			}, {
			site_url: pm_timg_tmce_obj.site_url,
			width_label: pm_timg_tmce_obj.width_label,
			height_label: pm_timg_tmce_obj.height_label,
			align_label: pm_timg_tmce_obj.align_label,
			align_none_label: pm_timg_tmce_obj.align_none_label,
			align_left_label: pm_timg_tmce_obj.align_left_label,
			align_center_label: pm_timg_tmce_obj.align_center_label,
			align_right_label: pm_timg_tmce_obj.align_right_label,
			insert_label: pm_timg_tmce_obj.insert_label,
			curr_img_key: values.img_key,
			curr_width: values.width,
			curr_height: values.height,
			curr_unit: values.unit,
			curr_align: values.align,
			images: pm_timg_tmce_obj.images,
			});
		}
	};
	wp.mce.views.register( shortcode_string, wp.mce.pm_tailored_img );
}(jQuery));